/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#ifndef flac123_H_
#define flac123_H_


#include <sys/types.h>

int flac123_init();
void flac123_deinit();
int flac123_fd();

void flac123_play(const char *path);
int flac123_stop();
int flac123_pause();
void flac123_fwd();
void flac123_rev();
void flac123_goto_frame(int frame);

int flac123_recv_message();

const char *flac123_time();
const char *flac123_time_remaining();
int flac123_current_frame();
int flac123_sample_rate();
int flac123_bit_rate();

int flac123_is_playing();
int flac123_is_paused();
int flac123_has_ended();

#endif
