/****************************************************************************
 *
 *   Copyright (C) 2003, 2004 Wolfgang G. Reissnegger, All Rights Reserved
 *
 *   gnagflow@users.sourceforge.net                                    
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the license, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public
 *   License along with this program;  if not, write to the
 *       Free Software Foundation, Inc.,
 *       59 Temple Place - Suite 330,
 *       Boston, MA 02111-1307
 *
 ****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <assert.h>
#include <dirent.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "main.h"

#include "main_menu.h"
#include "search_menu.h"
#include "session_menu.h"
#include "playlist_menu.h"

#include "display.h"
#include "info.h"
#include "player.h"
#include "song.h"
#include "defs.h"
#include "fileutil.h"
#include "hotkey.h"
#include "util.h"
#include "config_data.h"

#ifndef NDEBUG
#  include "dump.h"
#endif

/******************************************************************************/

void clearscreen(void)
{
printf("\033[2J");
printf("\033[H");
}

/******************************************************************************/

void print_titlescreen(void)
{
const char *const gn = "\033[0;40;32m";
const char *const bl = "\033[1;42;30m";
const char *const sp = "\033[0m";

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,sp,sp,sp,sp,bl,bl,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,bl,bl,bl,sp,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,sp,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,bl,bl,bl,bl,sp,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,sp,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,sp,bl,bl,sp,sp,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,sp,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,bl,bl,sp,sp,sp,bl,bl,bl,bl,sp,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,bl,bl,bl,sp,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,bl,bl,bl,bl,bl,sp,sp,sp,sp,bl,bl,bl,bl,sp,sp,sp,bl,bl,sp,sp,bl,bl,sp);

printf("%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s \n"
,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp,sp);

printf("\n%s          by Wolfgang Reissnegger, with some improvements by PPG & T.E.%s\n",gn,sp);
printf("\033[H\n");
printf("\033[?;25l\n");

}

/******************************************************************************/

static int oldstat;

/******************************************************************************/

static void exit_program(int val)
{
	display_close();

	player_shutdown();

	// Save the current filelist
	//
	file_entry_list_deinit();

	/* restore old (blocking) I/O */
	fcntl(0, F_SETFL, oldstat);
	system("stty sane");
	
	/* recall cursor */
	printf("\033[?;25h\n");

	exit(val);
}


/******************************************************************************/

void handle_key(unsigned int key)
{
	if (KEY_EXIT == key)
	{
		exit_program(0);
	}

	// Check, if we have a hotkey-handler defined for the current key.
	//
	if (KEY_HANDLED != hotkey_exec(key, NULL))
	{
		// No hotkey, pass it along to the current display.
		//
		display_handle_key(key);
	}
}


/******************************************************************************/

#define MAX_FD(_a,_b) ((_a)>(_b)?(_a):(_b))

static void main_loop()
{
	fd_set fds;

	// Main loop
	//
	for (;;)
	{
		struct timeval timeout = { 0, 300000 };

		// We have to read the player fd in every loop, because it may
		// change when player gets restarted.
		//
		int fd_player = player_fd();
		int fd_highest_disp;
		int fd_last;


		FD_ZERO(&fds);
		fd_highest_disp = display_fds(&fds);	// Fetch display fds
		FD_SET(fileno(stdin), &fds);	// PC keyboard
		if (fd_player)	// set player fd
		{
			FD_SET(fd_player, &fds);
		}
		fd_last = MAX_FD(fd_highest_disp, fd_player) + 1;


		if (0 < select(fd_last, &fds, NULL, NULL, &timeout))
		{
			char buffer[256];

			// Check keyboard input
			//
			if (FD_ISSET(fileno(stdin), &fds))
			{
				int len;
				int key;

				len = read(0, buffer, sizeof(buffer));
#ifndef NDEBUG
				dump_hex((unsigned char *) buffer, 0, len);
#endif

				key = keytab_eval(buffer, len);
#ifndef NDEBUG
				printf("%d\n", key);
#endif

				handle_key(key);
			}

			// check input from LCDd
			//
			display_handle_event(&fds);


			// Check input from player
			//
			if (fd_player && FD_ISSET(fd_player, &fds))
			{
				screen_t *song_screen;

				// Handle pending message for player.
				//
				(int) player_recv_message();

				// If a song is playing and this (screen) is
				// not the song screen, we have to update the
				// active song screen as well. This ensures
				// that info-data will be updated and the next
				// song will start once the current song ends.
				//
				song_screen = song_active_screen();

				if (song_screen &&
				    (song_screen != display_current_screen()) &&
				    song_screen->update)
				{
					song_screen->update(song_screen);
				}


			}
		}

		display_show();
	}
}


/******************************************************************************/

int main(int argc, char **argv)
{
	screen_t *info;
	int ch;
	unsigned int i;

	// At the very beginning, we try to open the config file.
	//
	// NOTE:
	//   The config file may be missing. This is OK...
	//
	config_data_read(AUDIOBOX_CONFIG_FILE);


	// Parse the command line arguments
	//
	while ((ch = getopt(argc, argv, "m:p:c:?")) != EOF)
	{
		switch (ch)
		{
		case 'm':
			DIR_MP3 = optarg;
			break;
		case 'p':
			DIR_PLAYLIST = optarg;
			break;
		case 'c':
			DIR_CDROM = optarg;
			break;

		case '?':
		default:
			printf("USAGE: %s [-?] [-m mp3-dir] [-p playlist-dir] [-c cdrom-dir]\n",
			       argv[0]);
			printf("    -m Set the mp3 root directory\n");
			printf("    -p Set the playlist directory\n");
			printf("    -c Set the cdrom directory\n");
			printf("    -? Print this help message\n");
			exit(0);
		}
	}
	argc -= optind;
	argv += optind;


	// Ctrl-C will cause a clean exit...
	signal(SIGINT, exit_program);
	// and "kill"...
	signal(SIGTERM, exit_program);
	// and "kill -HUP" (hangup)...
	signal(SIGHUP, exit_program);
	// and just in case, "kill -KILL" (which cannot be trapped; but oh well)
	signal(SIGKILL, exit_program);


	// Initialize the display
	//
	if (0 != display_init())
		exit_program(-1);

	// call init functions for all menus
	//
	search_menu_init();
	session_menu_init();
	playlist_menu_init();


	// Init the main menu for all sessions
	//
	for (i = 0; i < NUM_SESSION; ++i)
	{
		display_session_set(i);
		main_menu();
	}
	// Reset to session 0. This is our initial session we show to the user.
	//
	display_session_set(0);



	// Initialize the file entry list
	//
	info = info_new("audioBox " VERSION, 0);
	info_set_text(info, 1, "Scanning files...");
	display_push(info);
	display_show();


	file_entry_list_init();


	display_pop();

	// clear and display title screen 
	//
	clearscreen();
#ifdef NDEBUG
	printf("\n\n\n\n");
	print_titlescreen();
#endif
	// make I/O on stdin nonblocking 
	//
	system("stty raw -echo");	/* first put into a raw mode */
	oldstat = fcntl(fileno(stdin), F_GETFL, 0);
	fcntl(fileno(stdin), F_SETFL, oldstat | O_NDELAY);

	// Show initial menu
	//
	display_show();

	// Before we go into the main loop, we clear the config data space. We
	// should be done using the config data at this point...
	//
	// NOTE:
	//   This only clears the cached data. The config file is not open at
	//   this point.
	//
	config_data_clear();


	// go
	//
	main_loop();

	// Clean up
	exit_program(0);
	return 0;
}



// ------------------------------------------------------------------------------------------


